from tkinter import *
import random
from simpleClass import *
def randNomal():            #■正規分布乱数
    T=-6
    for i in range(12):T+=random.random()
    return T
def genNomalData(N, X0,Y0, diff, ID):#■正規分布による
    A=array(N,3)                     #  2次元データ生成
    for i in range(N): A[i][2]=ID
    for i in range(N): A[i][0]=int(randNomal()*diff+X0)
    for i in range(N): A[i][1]=int(randNomal()*diff+Y0)
    return A
def genCircleData(N,X0,Y0,R,ID):#■円状分布生成
    A=array(N,3);R2=R*R
    for i in range(N):
        X=int(random.random()*100); Y=int(random.random()*100)
        DX=X-X0;DY=Y-Y0;DL=DX*DX+DY*DY
        while DL>R2:# 円の外側のとき無視
            X=int(random.random()*100); Y=int(random.random()*100)
            DX=X-X0;DY=Y-Y0;DL=DX*DX+DY*DY
        A[i][0]=X; A[i][1]=Y;A[i][2]=ID
    return A
def setMap(A, ID):#■マップにクラスIDを設定する
    global MapDT; MX=len(MapDT[ID]);MY=len(MapDT[ID][0])
    for i in range(len(A)):
        X=A[i][0];Y=A[i][1]
        if (X>=0 and X<MX and Y>=0 and Y<MY):
            MapDT[ID][X][Y]=A[i][2]
def checkNear(ID,ID2,NRAN,comID, i,j):#■周辺チェック
    global MapDT; MX=len(MapDT[ID]);MY=len(MapDT[ID][0])
    flag=False;V0=MapDT[ID][i][j]; MapDT[ID2][i][j]=V0
    for k1 in range(-NRAN,NRAN+1):
        ii=i+k1
        if ii>=0 and ii<100:
            for k2 in range(-NRAN,NRAN+1):
                jj=j+k2 #近傍に他のクラスがあれば別クラス生成
                if jj>=0 and jj<100:
                    V2=MapDT[ID][ii][jj]
                    if V2!=0 and V0!=V2:
                        MapDT[ID2][i][j]=comID
                        flag=True;return
def setComID(ID,NRAN,comID=3):#■周辺に異なるクラスが
    global MapDT              #  あれば新クラス設定
    ID2=1-ID; MX=len(MapDT[ID]);MY=len(MapDT[ID][0])
    for i in range(MX):
        for j in range(MY):
            V0=MapDT[ID][i][j]
            if V0!=0:#周辺チェックと値設定
                checkNear(ID,ID2,NRAN,comID, i,j)
    return ID2
def drawCircle(canvas,X,Y,R,color="indigo"):#■円描画
    X0=X*2+40;Y0=300-Y*2;
    X1=X0-R*2;X2=X0+R*2; Y1=Y0-R*2;Y2=Y0+R*2
    canvas.create_oval(X1,Y1,X2,Y2,fill="",outline=color)
def drawRect(canvas,X,Y,R,color="indigo"):#■四角形
    X0=X*2+40;Y0=300-Y*2;
    X1=X0-R*2;X2=X0+R*2; Y1=Y0-R*2;Y2=Y0+R*2
    canvas.create_rectangle(X1,Y1,X2,Y2,fill="",outline=color)
testCase=[[30,40,70,60,20],  # テスト用
          [40,40,60,60,25],  # オーバラップ用
          [40,40,60,60,20],  # オーバラップ用
          [40,40,60,60,40],  # 正規分布用(飛び地発生)
          [25,25,75,75,20],  # case 1(右上がり
          [20,50,80,50,20],  # case 2(左右)
          [25,75,75,25,20],  # case 3(右下がり)
          [50,20,50,80,20]]  # case 4(上下)
root=Tk();root.title("Simple Classfier 2")
canvas=Canvas(root,width=500,height=400,bg="white")
canvas.pack();root.update()
#■データ設定
NDATA=200 #設定データ数
noCase=3 #テスト・ケース番号
XA=testCase[noCase][0];YA=testCase[noCase][1]
XB=testCase[noCase][2];YB=testCase[noCase][3]
R =testCase[noCase][4] 
random.seed(999) #完全に乱数にするには，これを注釈にする
#random.seed( 7) #完全に乱数にするには，これを注釈にする
setMethod=1     #データ設定方法
if setMethod==0:#円分布
    A=genCircleData(NDATA,XA,YA,R,1)
    B=genCircleData(NDATA,XB,YB,R,2)
else:#正規分布
    A=genNomalData(NDATA,XA,YA,R/3,1)
    B=genNomalData(NDATA,XB,YB,R/3,2)
setMap(A, 1); setMap(B, 1)
ID=setComID(1,5,comID=3)                
#■実行                
count=execClass(root, canvas)
#■最終表示
if setMethod==0:#円分布の場合，円描画
    drawCircle(canvas,XA,YA,R)
    drawCircle(canvas,XB,YB,R)
else:
    drawRect(canvas,XA,YA,R)
    drawRect(canvas,XB,YB,R)
dispFrame(canvas)
dispMap(canvas,A)
dispMap(canvas,B)
canvas.create_text(180,90,text="収れん回数"+str(count),
                   font=("Times",8),fill="black")




    


        

        
        

        
    


